/*
09/04/2012  Test OK a 115200 bds , en enlevant le TRACAGE !!!
Rajout 3 mesures ADC

 voir bluetooh_click_manual.pdf
 voir TEST MODULE BLUETOOTH.pdf
 voir Bluetooth-RN-UM.pdf
============================================================================
24/03/2012
New version MPLAB IDE 8.83.00
New version MPLAB C18 v3.41 (evaluation)
transposition de la version MikroC (OK en version demo 2K)

 * Project name:
	Project : 	18F46K22_Bluetooth.mcp
	main Source	: 18F46K22_BluetoothClick_link_Arkos_C18_1204105.c

     MCU:             PIC18F46K22
     Dev.Board:       Own breadboard
     Oscillator:      20.0000 MHz Crystal NO PLL used
     Ext. Modules:    Bluetooth click Board - ac:BT_click
                      2x16 Lcd character display - ac:Lcd
     Software:        MPLAB C18
			    Pickit2
			    Terminal Vray
			    Archos Side : RFO Basic

 * NOTES:
     - Attention  Bluetooth click board sous 3,3V
     - bluetooth password "1234".
     
     
=========== HARDWARE ====================
27 pf  Q=20Mhz 27pF
Interface DS275 pour liaison UART TTL <-> RS232 38400 bauds
LCD 2x16 cars

PIC 18F46K22  40 pins DIP
PortB
 RB0  33   input for IRC5 en interrupt TSOP1736
 RB1  34
 RB2  23
 RB3  24
 RB4  25
 RB5  26
 RB6  27  ICSP_Clck   Bleu fonc    Pin5 Pickit2
 RB7  28  ICSP_Data   Bleu clair    Pin4 Pickit2


PORTA
 RA0   2  Analog Input
 RA1   3  Analog Input
 RA2   4  Analog Input
 RA3   5  input
 RA4   6  Output .. Led .. 390 ohms +5V
 RA5   7  Output
 RA6   8  ----- Quartz 20Mhz   C=22pF -- Gnd
 RA7   9  ------ Quartz ---    C=22pF -- Gnd

PORTC
 RC0   15
 RC1   16
 RC2   17
 RC3   18
 RC4   23  CTRL  5_LCD     RS_PIN LCD
 RC5   24  CTRL  7_Enable  E_PIN LCD
 RC6   25  TX  RS232   UART1 Harware     1 de DS275 5 -> 3 Rx PC
 RC7   26  RX  RS232   UART1 Hardware    3 de DS275 7 <- 2 TX PC 

PORTD
 RD0   19
 RD1   20
 RD2   21
 RD3   22
 RD4   27   DATA    13_D4 LCD
 RD5   28   DATA    14_D5 LCD
 RD6   29   DATA    15_D6 LCD
 RD7   30   DATA    16_D7 LCD
       DATAS   7_D0_LCD ..10_LCD_D3  ...to Gnd
        1_LCD   Gnd power
        2_LCD   +5V power
        3_LCD   R=390 to Gnd

PORTE
 RE0   8
 RE1   9
 RE2   10
 RE3   1   MCLR via Rserie=1K to  R=2,7K to +5V et C=100nF to Gnd  diode//2,7K
      1   --- jaune -- VPP/MCLR ---  pin1 Pickit2
 VSS  12  ---- blanc ------Gnd-----  pin3 Pickit2
 VSS  12  ----  GND Power
 VSS  31  ----  GND Power
 VDD  11  ----  +5V Power
 VDD  32  ----  +5V Power

Module BlueTooth-Click T9JRN41-1  Mac@=0006607DB49
Gnd1 -> 0V
Gnd2 -> 0V
3,3V <- Out of LDxxx <- +5V
RX <-- R=750 <--- TX PIC
TX --> R=750 ---> Rx PIC


 */

#include "stdio.h"
#include <stdlib.h>
#include <delays.h>
#include <string.h>
#include <usart.h>   // pour fonctions UART
#include <adc.h>
#include <ctype.h>
#include <portb.h>
#include <timers.h>
#include <math.h>


#include "p18f46k22.h"


// config dans le code

// voir Help
//  Topics
//        Pic18
//            config bits settings
//                    choisir PIC18F46K22
#ifdef OSCILLATEUR_INTERNE
#pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=OFF            // CONFIG1H
#else
#pragma config FOSC = HSHP, PLLCFG=OFF, PRICLKEN=ON ,FCMEN=OFF
#endif
#pragma config IESO=OFF,PWRTEN=OFF,BOREN=OFF,WDTEN=OFF,CCP2MX=PORTC1
#pragma config PBADEN=OFF,CCP3MX=PORTE0,T3CMX=PORTC0,P2BMX=PORTC0
#pragma config MCLRE=EXTMCLR,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF                    // CONFIG5L
#pragma config CPB = OFF, CPD = OFF                                          // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF                // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                            // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF            // CONFIG7L
#pragma config EBTRB = OFF                                                   // CONFIG7H

#include "LCD_18F46K22.h"
#include "../_common/LCD2x16.h"

#define LCD
#ifndef Byte
#define Byte unsigned char
#endif

#define CLS 12
#define BS 8
#define TAB 9
#define CR 13
#define LF 10
#define Bell 7
#define ON 0	// logique inverse avec led tiree au +5V
#define OFF 1


#define Led_Rouge    PORTAbits.RA4
#define Allume 0
#define Eteint 1

#define OUT_RS232 Drapeaux.Lcd=0;
#define OUT_LCD Drapeaux.Lcd=1;
#define  LCD2x16

// DATA_PORT defines the port to which the LCD data lines are connected
#define LCD_DATAPORT       PORTD
#define LCD_DATAPORT_TRIS  TRISD
//CTRL_PORT defines the port where the control lines are connected.
//ReadWrite Pin
#define LCD_RWPIN       PORTCbits.RC3
#define LCD_RWPIN_TRIS  TRISCbits.TRISC3
//RS Pin
#define LCD_RSPIN       PORTCbits.RC4
#define LCD_RSPIN_TRIS  TRISCbits.TRISC4
//Enable Pin
#define LCD_ENPIN       PORTCbits.RC5
#define LCD_ENPIN_TRIS  TRISCbits.TRISC5
// Lcd module connections
#define LCD2x16

const long BAUDS=38400;

rom const char chaine0[]="Frame Erreur et Overflow detection : ";
rom const char chaine1[]="Port comm ...... bds, ouvert \r\n";
rom const char chaine2[]="18F46K22_BluetoothClick_link_Arkos_C18_120410.c \r\n";
rom const char chaine3[]="ESC pour sortir\r";
rom const char chaine4[]="J= ";
rom const char chaine5[]="Init BT Forcee (en aveugle)\r\n";
rom const char chaine6[]="Init BT Via machine d'etat (Tests des Retours)\r\n";

rom char *RS_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4,chaine5 ,chaine6  };

#pragma romdata EEP_=0xF00000

rom unsigned char EEPROM_data [][32] ={
      //   1234567890123456789012345678901
          "Projet:18F46K22 LCD UART1 BT  \r",//0  avec terminateur zero
          "Version 10/04/2012            \r",//20 avec terminateur zero
          "Port Com ouvert & Init HARDW. \r",//40  avec terminateur zero
          "Boucle en 2 Sec   <ESC> exit  \r",//60  avec terminateur zero
          "Avec UART1 HARDWARE.......... \r",//80  avec terminateur zero
          "paulfjujo@free.fr        \r\n",//A0   sans terminateur zero
          "MPLAB IDE V8.83  \r\n",
          "C18 v3.40.00   \r\n",0
          };
#pragma romdata




// #define TRACAGE  
// only if UART <=600 bauds Sinon utiliser le clavier car par car
// au lieu des touches macros  pour les retours 

#define MAX_LEN 80
#define DureeCycle 20               // * 1 diziemes de secondes => 2,0sec

/* responses to parse
const int BT_CMD=1;
const int BT_AOK=2;
const int BT_CONN=3;
const int BT_END=4;
*/


unsigned int  i,j,k;
unsigned int dummy;
unsigned int j1;
unsigned int M;
unsigned int BRG_REG;
volatile int i1;
volatile char  c1;
volatile int CMD_mode;
volatile int BT_state, DataReady;
volatile char response_rcvd;
volatile char responseID, response = 0;
volatile int CptFO,CptFE;
volatile unsigned int TimeEcoule;
volatile int count;
long L;

char Texte[MAX_LEN]="\0";//="18F46K22 BlueTooth tests C18\r\n";
char *txt=&Texte[0];
char F[9]="00000000";  // maxi 20MHz  "4294967296";
unsigned char Entree[17]="1234567890123456";
unsigned char *valtxt;
char buffer[MAX_LEN]="00000000000000000000000";	// buffer de reception
char received;
char *ptlec;		// pointeur de lecture
char *ptecr;		// pointeur d'ecriture
unsigned int CptCars;
unsigned int SaisieOk;


 struct chbits {   // 8 flags
                 unsigned FrameErr:1;
                 unsigned Over:1;
                 unsigned elligible:1;
                 unsigned Accumule:1;
                 unsigned Blc:1;
                 unsigned standby:1;
                 unsigned Fill:1;
                 unsigned Lcd:1;
               }Drapeaux ;

 union
{  unsigned char Fanion;
   struct chbits Drapeaux ;
} Flags;

#define OUT_RS232 Drapeaux.Lcd=0;
#define OUT_LCD Drapeaux.Lcd=1;

int BT_Get_Response(void);
void  BT_Configure(void);
void  Init_BT_direct(void);
void Init_UART1(void);
int PutStrR_RS(rom char *s);
int PutStr_RS(char *s);
void Put_RS(char * untel);
void CRLF(void);
void Write_Word_(unsigned int M,char Sign);
void fltToa (float x, unsigned char *str,char precision);
void print_flt(float W,int NbDeci,char Bold);
void Decompile_byte(Byte un);
void Octet2Hex(unsigned char number);
void Tempo(long val);
void Tempo_BT(void);

//---- EEPROM PIC Subroutines ================
unsigned char EEPROM_Lect(unsigned char adrL) ; // lecture a l'adresse adrL
void EEPROM_Ecr(unsigned char adrE,unsigned char car); // ecrit  a l'adresse adrE
void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(int PtrE);
void  Init_Hardware(void);


//------  EEPROM du PIC ---------------

unsigned char EEPROM_Lect(unsigned char adrL) // lecture a l'adresse adrL
{
	EEADR=adrL;
	EECON1bits.EEPGD=0;     // 0= adressage EEPROM
	EECON1bits.CFGS=0;      // 0= acces data EEPROM
	EECON1bits.RD=1;        // arme Lecture EEprom
	 Tempo(1000L);
	return(EEDATA);
}

void EEPROM_Ecr(unsigned char adrE,unsigned char car) // ecrit  a l'adresse adrE
{
	EEADR= adrE;
	EEDATA=car;
	EECON1bits.EEPGD=0;
	EECON1bits.WREN=1;            // autorise ecriture EEPROM
	EECON2=0x55;
	EECON2=0xAA;
	EECON1bits.WR=1;
	while (PIR2bits.EEIF==0);
	PIR2bits.EEIF=0;
	EECON1bits.WREN=0;
}

void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char * ptr1)
{
	while (*ptr1) EEPROM_Ecr(adrx++,*ptr1++);
}

void PrintOut_Eeprom_Msg(int PtrE)
{ int i;
  do
  {
  i = (int)EEPROM_Lect(PtrE);
  if ( i==0) break;

  Put_RS((Byte)i);
  PtrE++;
  if ( PtrE > 255) break;
   }
  while (i!=0)  ;
 Tempo(1000L);
}

void Tempo_BT()
{unsigned long LL;
 LL=500000;
 while(LL>0){LL--;}
}

//#define Init_BT_Normale   // init via machine d'etat ,sinon init force SANS TEST RETOUR

void  BT_Configure()
{
  OUT_LCD
  LCD_Erase_Ligne(1);LCD_PutRomString(" BT Configure   ");
  LCD_Erase_Ligne(2);LCD_PutRomString(" 1  $$$         ");
  OUT_RS232
  do {
    BT_state=0;
    dummy=PutStrR_RS("$$$");    // Enter command mode
   // Put_RS('$');Put_RS('$');Put_RS('$');
   Put_RS(13);
    Tempo_BT();
  }while (BT_Get_Response() != 1);
  Tempo(100000);
  OUT_LCD
  LCD_Erase_Ligne(2);LCD_PutRomString(" 2 SN,MyBT-DB49 ");
  OUT_RS232
  do {
    dummy=PutStrR_RS("SN,MyBT-DB49"); //Name of the device, 20 characters maximum
    Put_RS(13);
    Tempo_BT();
  } while (BT_Get_Response() != 2);
   Tempo(100000);
  OUT_LCD
  LCD_Erase_Ligne(2);LCD_PutRomString(" 3 SU,38.4      ");
  OUT_RS232
  do {
    dummy=PutStrR_RS("SU,38.4"); // Vitesse en bauds 38400
    Put_RS(13);
    Tempo_BT();
   }while (BT_Get_Response() != 2);
   Tempo(100000);
  OUT_LCD
  LCD_Erase_Ligne(2);LCD_PutRomString(" 4 SO,CONN      ");
  OUT_RS232
  do {
   dummy=PutStrR_RS("SO,CONN");   // Extended status string
   Put_RS(13);
    Tempo_BT();
   }while (BT_Get_Response() != 2);
 Tempo(100000);
   OUT_LCD
   LCD_Erase_Ligne(2);LCD_PutRomString(" 5 SM,0         ");
   OUT_RS232
   do {
    dummy=PutStrR_RS("SM,0");
  // Set mode (0 = slave, 1 = master, 2 = trigger, 3 =auto, 4 = DTR, 5 = ANY)
    Put_RS(13);
     Tempo_BT();
  } while (BT_Get_Response() != 2);
 Tempo(100000);
   OUT_LCD
   LCD_Erase_Ligne(2);LCD_PutRomString(" 6 SA,1         ");
   OUT_RS232
    do {
    dummy=PutStrR_RS("SA,1");    // Authentication (1 to enable, 0 to disable)
    Put_RS(13);
    Tempo_BT();
  } while (BT_Get_Response() != 2);
 Tempo(100000);
   OUT_LCD
   LCD_Erase_Ligne(2);LCD_PutRomString(" 7 SP,1234      ");
   OUT_RS232
   do {
    dummy=PutStrR_RS("SP,1234");  // Security pin code (mikroe)
    Put_RS(13);
    Tempo_BT();
  } while (BT_Get_Response() != 2);
 Tempo(100000);
   OUT_LCD
   LCD_Erase_Ligne(2);LCD_PutRomString(" 8 ---          ");
   OUT_RS232
   do {
    dummy=PutStrR_RS("---");
    Put_RS(13);
    Tempo_BT();
  } while (BT_Get_Response() != 4);   // BT_END
   // pour debug
   dummy=PutStrR_RS("Fin d'init\r\n");
}


void  Init_BT_direct()
{
    OUT_RS232
    dummy=PutStrR_RS("$$$");    // Enter command mode
    Put_RS(13);
    OUT_LCD
    LCD_Erase_Ligne(1); LCD_PutRomString(" 1 init mode CMD");
    LCD_Erase_Ligne(2); LCD_PutRomString("$$$             ");
    Tempo(100000);
     OUT_RS232
    dummy=PutStrR_RS("+");                  // Security pin code (mikroe)
    Put_RS(13);
    OUT_LCD                          // CR
    LCD_Erase_Ligne(1);LCD_PutRomString("active Echo     ");
    LCD_Erase_Ligne(2);
    Tempo(100000);
    OUT_RS232
    dummy=PutStrR_RS("SN,MyBT-DB49"); // Name of device
    Put_RS(13);
     OUT_LCD
    LCD_Erase_Ligne(1); LCD_PutRomString(" 2  Name ");
    LCD_Erase_Ligne(2); LCD_PutRomString("SN,MyBT-DB49    ");
    Tempo(100000);
    dummy=PutStrR_RS("SO,CONN");   // Extended status string
    Put_RS(13);
    LCD_Erase_Ligne(1);LCD_PutRomString(" 3 ");
    LCD_Erase_Ligne(2); LCD_PutRomString("SO,CONN         ");
    Tempo(100000);
    OUT_RS232
    dummy=PutStrR_RS("SM,0");
  // Set mode (0 = slave, 1 = master, 2 = trigger, 3 =auto, 4 = DTR, 5 = ANY)
    Put_RS(13);
     OUT_LCD
    LCD_Erase_Ligne(1);LCD_PutRomString(" 4 mode Slave   ");
    LCD_Erase_Ligne(2);LCD_PutRomString("SM,0            ");
    Tempo(100000);
    OUT_RS232
    dummy=PutStrR_RS("SA,1");    // Authentication (1 to enable, 0 to disable)
    Put_RS(13);
     OUT_LCD
    LCD_Erase_Ligne(1);LCD_PutRomString(" 5 Authentifie .");
    LCD_Erase_Ligne(2);LCD_PutRomString("SA,1            ");
    Tempo(100000);
    OUT_RS232
    dummy=PutStrR_RS("SP,1234");  // Security pin code (mikroe)
    Put_RS(13);
     OUT_LCD
    LCD_Erase_Ligne(1);LCD_PutRomString(" 6 Security Pin.");
    LCD_Erase_Ligne(2);LCD_PutRomString("SP,1234         ");
    Tempo(100000);
    OUT_RS232
    dummy=PutStrR_RS("SU,38.4");  // Speed uart defined with 4 caracteres
   // dummy=PutStrR_RS("SU,9600");  // Speed uart
    Put_RS(13);
    OUT_LCD
    LCD_Erase_Ligne(1);LCD_PutRomString("7 New Uart Speed");
    LCD_Erase_Ligne(2);LCD_PutRomString("SU,38.4         ");
    Tempo(100000);
    OUT_RS232
    dummy=PutStrR_RS("---");                  // Security pin code (mikroe)
    Put_RS(13);
     OUT_LCD                          // CR
    LCD_Erase_Ligne(1);LCD_PutRomString(" 8/8 mode Cde   ");
    LCD_Erase_Ligne(2);LCD_PutRomString("--- fin init    ");
    Tempo(100000);
     LCD_Erase_Ligne(2);
    LCD_Erase_Ligne(1);
}


 // Get BlueTooth response, if there is any
int BT_Get_Response()
 {
  if (response_rcvd)
  {
    response_rcvd = 0;
    return responseID;
  }
  else
    return 0;
}


//-------- interrupts---------------

void Serial_ISR(void);


 //gestionnaire d'interruption
//------------------------------
// High priority interrupt vector
#pragma code InterruptVectorHigh = 0x08
void InterruptVectorHigh (void)
{
  _asm
    goto Serial_ISR //jump to interrupt routine
  _endasm
}
#pragma code

#pragma interrupt Serial_ISR
void Serial_ISR()
 {
  if(PIR1bits.RC1IF==1) // si une interruption arrive
  {
   if(RCSTA1bits.FERR==1 )
   {
     RCSTA1bits.SPEN = 0 ;
     Flags.Drapeaux.FrameErr=1;
     CptFE++;
     RCSTA1bits.SPEN= 1 ;
     }
     else
     Flags.Drapeaux.FrameErr=0;

   if (RCSTA1bits.OERR==1)    // voir parag 16.1.26 p273
   {
       RCSTA1bits.CREN = 0 ;
       Flags.Drapeaux.Over=1;
       RCSTA1bits.CREN = 1 ;
       CptFO++;
       }
      else
      Flags.Drapeaux.Over=0;

   c1 =Read1USART(); // le lire => RAZ  RCIF
   while( Busy1USART()) ; // par scurite
   if (PORTBbits.RB1==0) Write1USART(c1); // echo
   if (CMD_mode==1)
   {
    /* The responses expected from the EasyBT module:
    CMD  +0D+0A
    ?    <- non trait ??
    AOK
    AOK
    AOK
    AOK
    AOK
    END
    ***ADVANCED
    ***Settings***
    */
    // Process reception through state machine
    // We are parsing CMD<cr><lf>, AOK<cr><lf>, CONN<cr> and END<cr><lf> responses
    switch (BT_state)
   {

      case  0:
              {
                response = 0;               // Clear response
                if (c1 == 'C')              // We have 'C', it could be CMD<cr><lf>  or CONN
                  BT_state = 1;             // Expecting 'M' or 'N'
                   else
                    if (c1 == 'A')          // We have 'A', it could be AOK<cr><lf>
                      BT_state = 11;        // expecting 'O'
                        else
                         if (c1 == 'E')     // We have 'E', it could be END<cr><lf>
                           BT_state = 31;   // expecting 'N'
                break;                      // ...
              }

      case  1: {
                if (c1 == 'M')
                   BT_state = 2;
                 else
                    if (c1 == 'O')
                      BT_state = 22;
                      else
              BT_state = 0;
              break;
            }

      case  2: {
                if (c1 == 'D')    // CMD
                 {
                   response=1;
                   BT_state = 40;
                }
                else
                BT_state = 0;
                break;
            }

      case 11: {
                if (c1 == 'O')
                  {
                    BT_state = 12;
                    }
                else
                BT_state = 0;
                break;
            }

      case 12: {
                if (c1 == 'K')
                {
                  response = 2;            // AOK
                  BT_state = 40;
                }
                else
                BT_state = 0;
                break;
            }

    case 22: {
                if (c1 == 'N')
                 BT_state = 23;
                else
                  BT_state = 0;
                break;
            }

      case 23: {
                if (c1 == 'N') {
                  response = 3;        // BT_CONN   Slave CONNected
                 BT_state = 40;
                 }
                BT_state = 0;
                break;
            }

      case 31: {
                if (c1 == 'N')
                  BT_state = 32;
                else
                  BT_state = 0;
                break;
             }

      case 32: {
                if (c1 == 'D')      // END
               {  response=4;
                 BT_state = 40;
                }
                else
                  BT_state = 0;
                break;
              }

      case 40:
              {
                if (c1 == CR)
                {
                  response_rcvd = 1;
                  responseID = response;
                }
                 BT_state = 0;
                 break;
              }
        default:
            {
                BT_state = 0;
                c1=0;
                break;
            }
    }// switch

   #ifdef TRACAGE    // NE PAS UTILISER A UART SPEED > 600 bds 
     Write_Word_(c1,0);Put_RS(TAB);
     Write_Word_(BT_state,0);Put_RS(TAB);
     Write_Word_(response,0);Put_RS(TAB);
    // Write_Word_(response_rcvd,0);
     Put_RS(TAB);
    // Write_Word_(responseID,0);Put_RS(TAB);
     Write_Word_(Flags.Fanion,0);
     CRLF();
  #endif

  } // if (CMD_mode==1
  else
  {
   if(c1 != CR )
     {
      buffer[i1] = c1;
      i1++;
      DataReady = 0;
     }
     else
      {
      buffer[i1] = 0;         //  0 a la fin du string
      DataReady = 1;      // drapeau Data recue
      i1=0;
    }
   }// if cmd=1
 } //if PIR1
  //PIR1bits.RC1IF=0;  // not accessible by software
 
 // =====  Timer1 interrupt ====
 if (PIR1bits.TMR1IF==1)
 {
      count ++;
       if (count >= DureeCycle)  // x 0.1S=> XXsec
        {
         count=0;
         TimeEcoule=1;
         Led_Rouge=!Led_Rouge;
        }
      WriteTimer1(3035);    // 62500*8*0.2 => 200000S  =0,1sec
      PIR1bits.TMR1IF = 0;
  }
}
//=============================================
void fltToa (float x, unsigned char *str,char precision)
{
/* converts a floating point number to an ascii string */
/* x is stored into str, which should be at least 30 chars long */
unsigned char *adpt;
int ie, i, k, ndig;
double y;
adpt=str;
ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
ie = 0;
/* if x negative, write minus and reverse */
if ( x < 0)
  {
  *str++ = '-';
  x = -x;
  }
/* put x in range 1 <= x < 10 */
if (x > 0.0) while (x < 1.0)
  {
  x *= 10.0;		// a la place de =*
  ie--;
  }
while (x >= 10.0)
  {
  x = x/10.0;
  ie++;
 }
 ndig += ie;				// a la place de =+
//round. x is between 1 and 10 and ndig will be printed to
// right of decimal point so rounding is ...
for (y = i = 1; i < ndig; i++)
  y = y/10.;
x += y/2.;
if (x >= 10.0) {x = 1.0; ie++;}
if (ie<0)
  {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
  }
for (i=0; i < ndig; i++)
  {
  k = x;
  *str++ = k + '0';
  if (i ==  ie ) *str++ = '.';
  x -= (y=k);
  x *= 10.0;
  }
*str = '\0';
//return (adpt);
}


void print_flt(float W,int NbDeci,char Bold)
{long lWhole;
 unsigned int ulPart;
 Drapeaux.Fill=0;
 lWhole=(long)(W);
 ulPart=(unsigned int)((W*(float)NbDeci)-(float)(lWhole*NbDeci));
 ultoa(lWhole,&Texte[0]);
 #ifdef LCD
 if (Drapeaux.Lcd) LCD_PutRamString(Texte);else k=PutStr_RS(Texte);
 if (Drapeaux.Lcd) LCD_Put('.'); else  Put_RS('.');
 #else
 k=PutStr_RS(Texte);
 Put_RS('.');
 #endif
  Write_Word_(ulPart,0);
}




void Write_Word_(unsigned int M,char Sign)
{
unsigned int i,k,l;
unsigned long M1;
 valtxt=&Entree[0];
 if (Sign>1) return;
 if (Sign==0)
  {       M1=M;
        ultoa(M1,&Entree[0]);
  }
  else itoa(M,&Entree[0]);
 if (Drapeaux.Fill)
 {
  k=strlen(Entree);
  for (i=0;i<k;i++) Entree[4+Sign-i]=Entree[k-i-1];
  for (i=0;i<(5+Sign-k);i++)
  {if (Drapeaux.Blc) Entree[i]='0'; else Entree[i]=' ';}
 }
 Entree[5+Sign]=0;
 #ifdef LCD2x16
 if (Drapeaux.Lcd==1) LCD_PutRamString(valtxt); else k=PutStr_RS(valtxt);
 #else
 k=PutStr_RS(valtxt);
 #endif
}

void Decompile_byte(Byte un) {
Byte masque;
  masque = 0x80;
  while (masque > 0u )
 {
  if (un & masque)
      if (Drapeaux.Lcd) LCD_Put(49u);  else Put_RS(49u);  //  '1'
    else
       if (Drapeaux.Lcd)LCD_Put(48u);   Put_RS(48u);  //  '0'
    masque =masque >>1;
     }
 }

void Octet2Hex(unsigned char number)
{
char high,low;
  // high nibble
  high = ((number & 0xF0) >> 4) + 48; // + '0'
  if (high > '9')
    high =high + 7;
 // low nibble
  low = (number & 0x0F) + 48;        // +'0' low nibble
  if (low > '9')  low += 7;          // '9'= 57u
  if (Drapeaux.Lcd) LCD_Put(high); else Put_RS(high);
  if (Drapeaux.Lcd) LCD_Put(low); else Put_RS(low);
  if (Drapeaux.Lcd) LCD_Put('h'); else Put_RS('h');
 }



void Init_UART1(void)
{
// USART_BRGH_HIGH,32
// init 38400Bd a 20Mhz
// init 19200Bd a 10Mhz avec IT en rx
// voir para 18.5 spec sheet DS41159B page 186
// 9600   130 @ 20MHz 
// 19200  64 @ 20MHz 
// 38400  32 @ 20MHz 
// 115200  10 @ 20MHz 
switch ( BAUDS)
{
    case 9600: BRG_REG=130;break;
    case 19200: BRG_REG=64;break;
    case 38400: BRG_REG=32;break;
    case 115200: BRG_REG=10;break;
    default: 
    BRG_REG=130;
     break;

}
Open1USART( USART_TX_INT_OFF &
USART_RX_INT_ON &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
//USART_CONT_RX &
USART_SINGLE_RX &
USART_BRGH_HIGH,BRG_REG 
); //130 pour 9600 bds @20Mhz
IPR1bits.RC1IP=1;  // high priority for UART
RCONbits.IPEN = 1;     // Enable High interrupt priority model.
PIE1bits.RC1IE = 0;
INTCONbits.PEIE = 0 ; // autorisation des IT des priphriques
INTCONbits.GIE = 0 ; // autorisation globale des IT
}

int PutStrR_RS(rom char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}


int PutStr_RS(char *s)
{
	int n;
	for (n = 0; *s; n++, s++)
	{
       	Put_RS(*s);
     	}
	return n;
}

void Put_RS(char * untel)
{
   	while(Busy1USART());
   	Write1USART(untel);
}

void CRLF()
{
  Put_RS(CR);  Put_RS(LF);
  }

//Tempo(2.500.000);  9.5sec avec Q=20Mhz
// Tempo(250.000);  2,2 sec avec Q=20Mhz
void Tempo(long val)
{
while(val>0){val--;}
}

void Init_Hardware()
 {
   PMD0bits.UART2MD=1;  // USART2 disabled
   PMD0bits.UART1MD=0;
   PMD0bits.TMR6MD=1;   // Timer6 disable
   PMD0bits.TMR5MD=1;   // Timer5 disable
   PMD0bits.TMR4MD=1;   // Timer4 disable
   PMD0bits.TMR3MD=1;   // Timer3 disable
   PMD0bits.TMR2MD=1;   // Timer2 disable
   PMD0bits.TMR1MD=0;   // Timer1 Enable

   PMD1bits.MSSP2MD=1;   // MSSP2 disabled
   PMD1bits.MSSP1MD=1;   // MSSP1 disabled
   PMD1bits.CCP5MD=1;   // Disabled
   PMD1bits.CCP4MD=1;   // Disabled
   PMD1bits.CCP3MD=1;   // Disabled
   PMD1bits.CCP2MD=1;   // Disabled
   PMD1bits.CCP1MD=1;   // Disabled

   PMD2bits.CTMUMD=1;   // Disabled
   PMD2bits.CMP2MD=1;   // Disabled
   PMD2bits.CMP1MD=1;   // Disabled
   PMD2bits.ADCMD=0;    // Enable

   PORTB = 0xFF;
   TRISB = 0xFF;
   TRISBbits.TRISB0=1;   	// B0 <- IR input
   TRISBbits.TRISB1=1;   	// B1 input for debug echo reception
   TRISBbits.TRISB2=0;   	// B2 led
   TRISBbits.TRISB3=1;		// B3 not used
   TRISBbits.TRISB4=1;		// B4 not used
   TRISBbits.TRISB5=1;		// B5 not used
   TRISBbits.TRISB6=1;      // B6 not used
   TRISBbits.TRISB7=1;      // B7 not used
   WPUB=0x02;               // any pin pull up
   INTCON2bits.RBPU=0;      // enable Pull-up

  // ATTENTION a l'ordre des canaux ANALOGIQUES !!!
  ANSELB=0;              // No analog input,PortB digital
  ANSELA=0;
  ANSELAbits.ANSA0=1;    //  analog input on Port A   voir page 154
  ANSELAbits.ANSA1=1;
  ANSELAbits.ANSA2=1;
  TRISA = 0b00001111 ;   // PORTA is RA0,1,2,= analog input  RA3=input,4,5=Digital output
  LATA = 0x00;

  PORTC = 0xFF;          // set PORTC to $FF
  ANSELC=0;
  TRISC = 0b10000000;    // all output expect RC7
  TRISCbits.TRISC0 = 0;
  TRISCbits.TRISC1 = 0;
  TRISCbits.TRISC2 = 0;
  TRISCbits.TRISC3 = 0;
  TRISCbits.TRISC4 = 0;  // R/S LCD
  TRISCbits.TRISC5 = 0;  // EN LCD
  TRISCbits.TRISC6 = 0;  // TX - Set as Output UART RS232 and Bootloader
  TRISCbits.TRISC7 = 1;  // RX - Set Receive pin for UART RS232 and Bootloader

  ANSELD=0;
  TRISD=0;              // all outputs

  ANSELE=0;

  RCONbits.IPEN=1   ; // enable priority levels
  RCONbits.SBOREN=0;  //  BOR disbled

  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }
 
 
void Init_Timer1()
{
 //--- init timer
 //see PIC18F25K22_46K22_41412E.pdf  12.13 page 172
  T1CONbits.TMR1CS1=0;
  T1CONbits.TMR1CS0=0; // clock source= Fosc/4
  T1CONbits.T1CKPS1=1;
  T1CONbits.T1CKPS0=1; // prescaler =1/8
  T1CONbits.T1SOSCEN=0; // Secondary Oscillator Disabled
  T1CONbits.T1SYNC=0;   // Synchro extern clock input with Fosc  (ignore)
  T1CONbits.T1RD16=1 ;  // Mode 16 bits
  T1CONbits.TMR1ON=0;   // Stop timer1
  //---
  T1GCONbits.TMR1GE=0;  // allways count if TMR1ON=1
  T1GCONbits.T1GTM=0;   // Toogle Gate mode disabled
  T1GCONbits.T1GSS1=0;  // Timer1 gate pin
  T1GCONbits.T1GSS0=0;
  //----
  IPR1bits.TMR1IP=1;      // set hihh priority for Timer1
  RCONbits.IPEN = 1;      // Enable High interrupt priority model.
  WriteTimer1(3035);      // 62500*8*4*0.1 => 200000S  =0,2sec
  PIR1bits.TMR1IF=0;      // raz flag interrupt
  INTCONbits.PEIE = 0;    // enable interupt Peripheriques
  T1CONbits.TMR1ON=0;     // desactive Timer1
  PIE1bits.TMR1IE=0;      // Enable Interrupt Timer1
  INTCONbits.GIE = 0;     // active global interrupt
  INTCONbits.GIEL=0;      // active les priorites  (par8 page 79 docu PIC18Fxx8)

}


void main()
 {
  Init_Hardware();
  // Initialize variables
  Flags.Fanion=0;
  Flags.Drapeaux.Fill=1;
  Flags.Drapeaux.Blc=1;

  DataReady = 0;
  buffer[0]=0;
  OUT_RS232
  Init_UART1();         // 38400 bds at 20MHz
  while(DataRdy1USART())
 {
  c1=getc1USART();
  }
  c1=0;
  Put_RS(CLS);
  Tempo(100000);
  PrintOut_Eeprom_Msg(0x00);
  PrintOut_Eeprom_Msg(0x20);
  PrintOut_Eeprom_Msg(0x40);
  PrintOut_Eeprom_Msg(0x60);

  txt=&Texte[0];
  strcpypgm2ram(txt,RS_Str[1]); 
  L=BAUDS;
  ltoa(L,txt+10);
  i=strlen(txt);
  *(txt+i)='.';
   k=PutStr_RS(txt);
  //strcpypgm2ram(txt,RS_Str[2]);  k=PutStr_RS(txt);
  dummy=PutStrR_RS(RS_Str[2]);
   #ifdef Init_BT_Normale
  dummy=PutStrR_RS(RS_Str[6]);
  #else
  dummy=PutStrR_RS(RS_Str[5]);
  #endif
  CRLF();
  
  Init_Timer1(); // 2 sec

  OUT_LCD
  LCD_Init();                   // Lcd Init
  LCD_Cde(0x01);      // Clear display
  LCD_Cde(0x0E);     // Turn cursor off

  // Display starting messages
  LCD_Pos(1,0);
  LCD_PutRomString("BlueTooth-Click!");
  LCD_Pos(2,0);
  LCD_PutRomString("Test with Archos");
  Tempo(250000);

  LCD_Clear();
  LCD_Pos(1,0);
  LCD_PutRomString("Init BT en cours");
  LCD_Pos(2,0);
  LCD_PutRomString("..Attendre,SVP..");
  Tempo(250000);


  INTCONbits.GIE = 1;    // active global interrupt
  INTCONbits.GIEL=1;
  RCSTA1bits.CREN= 1 ;
  PIE1bits.RC1IE = 0;
  INTCONbits.PEIE = 1;   // autorisation des IT des priphriques

  OUT_RS232
  BT_state = 0;
  response_rcvd = 0;
  responseID = 0;
  response = 0;
  c1 = 0;
  i1=0;
  CptFO=0;
  CptFE=0;
  Flags.Drapeaux.FrameErr=0;
  Flags.Drapeaux.Over=0;
 // Configure BlueTooth-Click module
 #ifdef Init_BT_Normale
   CMD_mode = 1;
   PIE1bits.RC1IE = 1;
   BT_Configure();    // avec test retour
   CMD_mode = 0;
 #else
   CMD_mode = 0;
   Init_BT_direct();  // aveugle sans test des retour
 #endif
 if (CptFE>0  || CptFO>0)
  {
      dummy=PutStrR_RS(RS_Str[0]);
      Put_RS(TAB); Write_Word_(CptFE,0);Put_RS(TAB);Write_Word_(CptFO,0);
      CRLF();
  }

  i1=0;
  CRLF();
  OUT_LCD
  LCD_Clear();          //  Clear display
  CMD_mode = 0;
  DataReady = 0;         // Data not received

  LCD_Clear() ;          // Clear display
  LCD_Pos(1,0);
  LCD_PutRomString("Init BT Terminee");    // Display message
  OUT_RS232
  dummy=PutStrR_RS("MyBT-DB49 Connected!");   //  Send message on connection
  Put_RS(13);              // CR
  OUT_LCD
  LCD_Pos(2,0);
  LCD_PutRomString("En Ecoute...    ");  // Display message

  DataReady = 0;         // Data not received
  j1=0;                    // Initialize counter
  
 // start timer1
  count=0;
  INTCONbits.GIE = 1 ; // autorisation globale des IT
  PIE1bits.TMR1IE=1;      // Enable Interrupt Timer1
  T1CONbits.TMR1ON=1;     // Active Timer1
  
   //config lecture ADC 10 bits
 ADCON0bits.ADON=1;      // ADC enabled chanel 0
 ADCON1bits.TRIGSEL=0 ; // trigger from CCP5
 ADCON2bits.ADFM=1;     // right justified
 ADCON2bits.ACQT2=1;
 ADCON2bits.ACQT1=1;
 ADCON2bits.ACQT0=0;    // 16 TAD
 ADCON2bits.ADCS2=0;
 ADCON2bits.ADCS1=1;
 ADCON2bits.ADCS0=0;    // Fosc/32
 ADCON1bits.PVCFG1=0;   // +Vref = +5V AVdd
 ADCON1bits.PVCFG0=0;
 ADCON1bits.NVCFG1=0;   // -Vref = Gnd AVss
 ADCON1bits.NVCFG0=0;
  
  
//========= Main loop ==============
do
  {
   TimeEcoule=0;
   OUT_RS232
   PIE1bits.RC1IE = 1;
   Write_Word_(j1,0); // envoi la valeur de j
   CRLF();    // si CR  pas de cesure de message, si cRLF separation de message
   Tempo(5000L);
 // lecture 3 chanels ANA
  for (j=0;j<3;j++)
 {
  //ADCON0bits.ADON=1;
  ADCON0=1 + (j<<2);   // ADON=1 et choix de canal 
  Delay10TCYx( 10 ); // Delay for 100TCY
  ConvertADC(); // Start conversion
  while( BusyADC() );
  M = ReadADC(); // Read result
  itoa(M,txt);
  Put_RS('M');
  Put_RS(j+48);
  Put_RS('=');
  k=PutStr_RS(txt);
  if (j<2)Put_RS(' ');Put_RS(';');Put_RS(' '); // separateur de champs
  Tempo(5000L);
  }
  Put_RS(' ');Put_RS('$');
  CRLF();
       
  OUT_LCD
  LCD_Erase_Ligne(1);
  LCD_PutRomString("Envoi :");
  LCD_Pos(1,8); Write_Word_(j1,0);

  if(DataReady==1)
    {
        PIE1bits.RC1IE = 0;
       // data is received
        DataReady = 0;          // Raz flag Data received
        LCD_Erase_Ligne(2);
        i=0;
        while (buffer[i] != 0)
        {
            LCD_Put(buffer[i]); // Displaying the received text on the LCD
        i++;                    // Increment counter
        }
         PIE1bits.RC1IE = 1;
    }
   j1++;
  do
  {  // attente synchro timer1 2 sec
  }
 while (TimeEcoule==0);
 }
while(1);
}
//*************************************************************


/*
Historique:
08/04/2012    Presque OK !!!
    Test machine d'etat connect avec terminal, rajout tracage reponses
    PB d'erreur OVER Fifo si envoi contigu de caracteres
    No problemo si envoi au clavier (dans le temps imparti ?)
05/04/2012
PB avec machine d'etat ..
03/04/2012
usage buffer dans IT UART ..  PB de reception!!
25/03/2012
Test en C18
Boof ....
PB: Je perds la config via termminal @115200 bauds !
    aucune reaction a $$$
Verif terminal
sur interface RS232 DS275 boucle cot TTL entre Tx=1 et Rx=3 => cra cra sur ecran
il faut descendre la vitesse a 38400 bds pour avoir un echo correct !
Impossible de re-obtenir la config BT via terminal
echange DS275 -> negatif  ..idem
usage de la Notice Bluetooth-RN-UM.pdf page 6  para 3.4
Using dip switch and PIO for config :
Essai de Factory Reset avec PIO4 reli a la masse -> negatif
 Strap J4 pour relier PIO4 au +3V via rappel R3 de 1K (voir schema)
 Negatif
Essai de modifier Baudrate a 9600 bds
 en strappant J5 PIO7 reli au +3V via R4=1K
 ON=9600   OFF=115200
 OK j'ai a nouveau sur l'ordre "$$$"  le retour "CMD"  a 9600 bds sur le terminal
 -----------------------------
 Modif Config :
 BTA=00066607DB49
 BTName=MyBT-DB49		<- nouveau nom
 Baudrt=38.4			<- nouvelle vitesse
 -------------------------------
 sur terminal reli a MyBT-DB49
 IS   <- commande
 Inquiry, COD=0
 Found 1
 D8952F3FF710,Archos43,58020C
 Inquiry Done
 --------------------------------
 Sur ARchos43
 Par contre l'Archos ne voit pas de suite le nouveau nom, reste sur Bluetooth-Click
 pendant plusieuirs minutes ..puis OK , voit MyBT-DB49
 associer avec code pin 1234
 Reli mais pas connect .. OK
 */
 /*  Test avec Terminal OK at 115200 bauds
12:14:49.142> Projet:18F46K22 LCD UART1 BT  
12:14:49.392> Version 09/04/2012            
12:14:49.642> Port Com ouvert & Init HARDW. 
12:14:49.893> Boucle en 1 Sec   <ESC> exit  
12:14:49.943> Port comm 115200.bds, ouvert 
12:14:49.943> 18F46K22_BluetoothClick_link_Arkos_C18_120409.c 
12:14:49.943> Init BT Via machine d'etat (Tests des Retours)
12:14:49.943> 
12:14:54.449> $$$
12:14:56.953> $$$
12:14:59.456> $$$
12:15:02.861> SN,MyBT-DB49
12:15:05.365> SN,MyBT-DB49
12:15:08.770> SU,38.4
12:15:12.175> SO,CONN
12:15:15.580> SM,0
12:15:19.035> SA,1
12:15:22.439> SP,1234
12:15:25.844> ---
12:15:28.348> Fin d'init
12:15:28.348> 
12:15:28.398> MyBT-DB49 Connected!
12:15:28.498> 0
12:15:30.151> 1
12:15:31.803> 2
12:15:33.455> 3
12:15:35.158> 4
12:15:36.810> 5
12:15:38.462> 6
12:15:40.115> 7
12:15:41.817> 8
12:15:43.470> 9
12:15:45.222> 10
12:15:46.875> 11
12:15:48.527> 12
12:15:50.229> 13
12:15:51.882> 14
12:15:53.534> 15
12:15:55.237> 16
12:15:56.889> 17
*/



/*   test avec TERMINAL !!! not Bluetooth device
     Probleme avec machine d'etat et init normale avec retour dialogue
     avec utilisation du TRACAGE
     sinon c'est OK avec introduction des retour car par car au clavier!
17:09:57.528> Projet:18F46K22 LCD UART1 BT
17:09:57.779> Version 08/04/2012
17:09:58.029> Port Com 38400bds & Init HARD.
17:09:58.279> Boucle en 1 Sec   <ESC> exit
17:09:58.329> Port comm 38400 ouvert ... String en ROM
17:09:58.380> 18F46K22_BluetoothClick_link_Arkos_C18_120408.c
17:09:58.380> Init BT Via machine d'etat (Tests des Retours)
17:09:58.380>
17:10:02.886> $$$
17:10:05.390> $$$
17:10:06.792> 67	1	0		80
17:10:06.792> 77	2	0		82=Over !! si envoi 4 caracteres colls
17:10:06.792> 68	40	1		80
17:10:07.943> $$$
17:10:10.447> $$$
17:10:11.649> 67	1	0		80  A   No FramErr or OVer si tap au clavier !
17:10:11.899> 77	2	0		80  O
17:10:12.049> 68	40	1		80  K
17:10:12.199> 13	0	1		80  cr
17:10:13.852> SN,MyBT-DB49
17:10:15.254> 65	11	0		80 A    au clavier !
17:10:15.554> 79	12	0		80 O
17:10:15.754> 75	40	2		80 K
17:10:16.055> 13	0	2		80 cr
17:10:17.307> SU,38.4
17:10:18.709> 13	0	0		80
17:10:19.810> SU,38.4
17:10:20.862> 65	11	0		80
17:10:21.012> 79	12	0		80
17:10:21.212> 75	40	2		80
17:10:21.463> 13	0	2		80
17:10:23.265> SO,CONN
17:10:24.217> 65	11	0		80
17:10:24.367> 79	12	0		80
17:10:24.517> 75	40	2		80
17:10:24.767> 13	0	2		80
17:10:26.720> SM,0
17:10:27.471> 65	11	0		80
17:10:27.571> 79	12	0		80
17:10:27.772> 75	40	2		80
17:10:28.072> 13	0	2		80
17:10:30.175> SA,1
17:10:32.679> SA,1
17:10:33.780> 65	11	0		80
17:10:33.780> 79	12	0		82 <- OVER erreur si cars contigus
17:10:33.780> 75	40	2		80
17:10:35.182> SA,1
17:10:37.586> 13	0	2		80
17:10:38.587> SP,1234
17:10:38.738> 65	11	0		80  A
17:10:38.938> 79	12	0		80  O
17:10:39.088> 75	40	2		80  K
17:10:39.388> 13	0	2		80  cr
17:10:42.042> ---
17:10:44.546> ---
17:10:45.698> 69	31	0		80  E
17:10:45.948> 78	32	0		80  N
17:10:46.048> 68	40	4		80  D
17:10:46.298> 13	0	4		80  cr
17:10:47.100> Fin d'init
*/
/*
Mon Apr 09 19:53:17 2012
----------------------------------------------------------------------
Clean: Deleting intermediary and output files.
Clean: Deleted file "C:\_C18\tmp\18F46K22_BluetoothClick_link_Arkos_C18_120410.o".
Clean: Deleted file "C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BT_Archos.cof".
Clean: Deleted file "C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BT_Archos.hex".
Clean: Deleted file "C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BT_Archos.map".
Clean: Done.
Executing: "C:\Program Files\Microchip\mplabc18\bin\mcc18.exe" -p=18F46K22 /i"C:\_C18\h" "18F46K22_BluetoothClick_link_Arkos_C18_120410.c" -fo="C:\_C18\tmp\18F46K22_BluetoothClick_link_Arkos_C18_120410.o" -k -Oi -Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa-
MPLAB C18 v3.41 (evaluation)
Copyright 2000-2011 Microchip Technology Inc.
Days remaining until evaluation becomes feature limited:  60
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:328:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:338:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:357:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:358:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:362:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:364:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:369:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:372:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:373:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:378:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:381:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:382:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:387:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:390:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:391:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:396:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:399:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:401:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:406:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:409:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:410:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:415:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:418:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:419:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:424:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:427:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:428:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:432:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:439:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:440:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:442:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:443:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:446:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:447:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:449:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:453:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:454:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:456:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:457:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:459:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:460:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:461:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:462:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:465:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:467:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:469:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:470:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:473:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:474:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:476:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:477:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:480:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:481:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:483:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:484:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:487:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:489:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:491:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:492:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:495:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:496:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:498:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:499:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:800:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:843:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:845:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:860:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:861:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:862:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:908:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:919:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:927:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:932:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:932:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1060:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1068:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1083:Warning [2058] call of function without prototype
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1092:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1094:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1099:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1101:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1135:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1135:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1148:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1150:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1151:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1154:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1200:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1201:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1202:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1204:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1204:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1204:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1207:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1207:Warning [2054] suspicious pointer conversion
C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BluetoothClick_link_Arkos_C18_120410.c:1212:Warning [2066] type qualifier mismatch in assignment
Executing: "C:\Program Files\Microchip\mplabc18\bin\mplink.exe" /p18F46K22 /l"C:\_C18\lib" /k"C:\_C18\bin\LKR" "..\_common\18f46k22_GrosseBank.lkr" "..\..\tmp\18F46K22_BluetoothClick_link_Arkos_C18_120410.o" /u_CRUNTIME /z__MPLAB_BUILD=1 /m"C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BT_Archos.map" /w /o"C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BT_Archos.cof"
MPLINK 4.42, Linker
Device Database Version 1.7
Copyright (c) 1998-2011 Microchip Technology Inc.
Errors    : 0

MP2HEX 4.42, COFF to HEX File Converter
Copyright (c) 1998-2011 Microchip Technology Inc.
Errors    : 0

Loaded C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BT_Archos.cof.
----------------------------------------------------------------------
Release build of project `C:\_C18\_MesProjets_C18\_18F46K22\18F46K22_BT_Archos.mcp' succeeded.
Language tool versions: mpasmwin.exe v5.44, mplink.exe v4.42, mcc18.exe v3.41, mplib.exe v4.42
Mon Apr 09 19:53:24 2012
----------------------------------------------------------------------
BUILD SUCCEEDED*/